function env = envgen(t,a,method);     %t= vector of control time instants
                                       %a= vector of envelope vaues

global Fs; global SpF;    %global variables: sample rate, samples-per-frame

if (nargin<3) method='linear'; end

frt=floor(t*Fs/SpF+1);                 %control time instants as frame numbers
nframes=frt(length(frt));              %total number of frames
env=interp1(frt,a,[1:nframes],method); %linear (or other method) interpolation
